#include <windows.h>
#include <windowsx.h>
#include <stdio.h>
#include <string.h>
#include "winips.h"
#include "ips.h"
#include "ipslib.h"
#include "myfunc.h"

BOOL IsIPSFile(LPCTSTR lpFilePath)
{
	return ips_IsIPSFile(lpFilePath);
}

BOOL CreateIPSFile(LPIPSLIBPARAMS lpParams)
{
	LPTSTR lpOrgPath = lpParams->szFilePath1;
	LPTSTR lpChgPath = lpParams->szFilePath2;
	HWND hwndParent = lpParams->hWnd;
	BOOL blYesNo = TRUE; // R}hCɂĂяoŁAbZ[W{bNXYES{^ɂׂTRUEŏB
	TCHAR szLog[LOG_BUFFER_SIZE];
	TCHAR cIPSBuf[MAX_PATH];
	TCHAR szMsg[MAX_PATH*3+100];

	SendMessage(hwndParent,WM_IPSLIB_BEGIN,0,0);

	if(!CheckFileExistance(lpOrgPath)){
		wsprintf(szMsg,"%s ́A݂܂B",lpOrgPath);
		SendMessage(hwndParent,WM_IPSLIB_FINISH,FALSE,(LPARAM)szMsg);
		return FALSE;
	}

	if(!CheckFileExistance(lpChgPath)){
		wsprintf(szMsg,"%s ́A݂܂B",lpChgPath);
		SendMessage(hwndParent,WM_IPSLIB_FINISH,FALSE,(LPARAM)szMsg);
		return FALSE;
	}

	if(!lstrcmp(lpOrgPath,lpChgPath)){
		wsprintf(szMsg,"2̧ٖɂȂĂ܂B");
		SendMessage(hwndParent,WM_IPSLIB_FINISH,FALSE,(LPARAM)szMsg);
		return FALSE;
	}

	ChangeFileExtention(lpChgPath,cIPSBuf,MAX_PATH*sizeof(TCHAR),"ips");

	wsprintf(szMsg,"ύXO̧\n%s\nύX̧\n%s\n߯sIPŞ\n%s\n쐬܂B\n낵ł?",lpOrgPath,lpChgPath,cIPSBuf);
	SendMessage(hwndParent,WM_IPSLIB_CONFIRM,(WPARAM)&blYesNo,(LPARAM)szMsg);
	if(!blYesNo){
		SendMessage(hwndParent,WM_IPSLIB_FINISH,FALSE,(LPARAM)NULL);
		return FALSE;
	}

	if(CheckFileExistance(cIPSBuf)){
		wsprintf(szMsg,"%s ́Ałɑ݂Ă܂B\n㏑Ă낵łH",cIPSBuf);
		SendMessage(hwndParent,WM_IPSLIB_CONFIRM,(WPARAM)&blYesNo,(LPARAM)szMsg);
		if(!blYesNo){
			SendMessage(hwndParent,WM_IPSLIB_FINISH,FALSE,(LPARAM)NULL);
			return FALSE;
		}
	}

	if(ips_Create(lpOrgPath,lpChgPath,cIPSBuf,szLog,hwndParent,WM_IPSLIB_PROGRESS)){
		SendMessage(hwndParent,WM_IPSLIB_FINISH,TRUE,(LPARAM)szLog);
	}
	else{
		DeleteFile(cIPSBuf);
		SendMessage(hwndParent,WM_IPSLIB_FINISH,FALSE,(LPARAM)szLog);
	}
	return TRUE;
}

BOOL IPSPatch(LPIPSLIBPARAMS lpParams)
{
	LPTSTR lpIPSPath = lpParams->szFilePath1;
	LPTSTR lpSrcPath = lpParams->szFilePath2;
	HWND hwndParent = lpParams->hWnd;
	BOOL blYesNo = TRUE; // R}hCɂĂяoŁAbZ[W{bNXYES{^ɂׂTRUEŏB
	TCHAR szLog[LOG_BUFFER_SIZE];
	TCHAR cNewBuf[MAX_PATH];
	TCHAR cSrcFileExt[MAX_PATH];
	TCHAR szMsg[MAX_PATH*3+100];

	SendMessage(hwndParent,WM_IPSLIB_BEGIN,0,0);

	if(!CheckFileExistance(lpIPSPath)){
		wsprintf(szMsg,"%s ́A݂܂B",lpIPSPath);
		SendMessage(hwndParent,WM_IPSLIB_FINISH,FALSE,(LPARAM)szMsg);
		return FALSE;
	}

	if(!CheckFileExistance(lpSrcPath)){
		wsprintf(szMsg,"%s ́A݂܂B",lpSrcPath);
		SendMessage(hwndParent,WM_IPSLIB_FINISH,FALSE,(LPARAM)szMsg);
		return FALSE;
	}

	if(!ips_IsIPSFile(lpIPSPath)){
		wsprintf(szMsg,"%s ́AIPŞقł͂܂B",lpIPSPath);
		SendMessage(hwndParent,WM_IPSLIB_FINISH,FALSE,(LPARAM)szMsg);
		return FALSE;
	}

	if(!lstrcmp(lpIPSPath,lpSrcPath)){
		wsprintf(szMsg,"2̧ٖɂȂĂ܂B");
		SendMessage(hwndParent,WM_IPSLIB_FINISH,FALSE,(LPARAM)szMsg);
		return FALSE;
	}

	GetFileExtention(lpSrcPath,cSrcFileExt,sizeof(cSrcFileExt));
	ChangeFileExtention(lpIPSPath,cNewBuf,MAX_PATH,cSrcFileExt);

	wsprintf(szMsg,"̧߯\n%s\n̺߰\n%s\n쐬A̧قIPŞ\n%s\n߯܂B\n낵ł?",lpSrcPath,cNewBuf,lpIPSPath);
	SendMessage(hwndParent,WM_IPSLIB_CONFIRM,(WPARAM)&blYesNo,(LPARAM)szMsg);
	if(!blYesNo){
		SendMessage(hwndParent,WM_IPSLIB_FINISH,FALSE,(LPARAM)NULL);
		return FALSE;
	}

	if(!_stricmp(cNewBuf,lpSrcPath)){
		wsprintf(szMsg,"̧߯قƂ̧̺߰قɂȂĂ܂߯s܂B");
		SendMessage(hwndParent,WM_IPSLIB_FINISH,FALSE,(LPARAM)szMsg);
		return FALSE;
	}

	if(CheckFileExistance(cNewBuf)){
		wsprintf(szMsg,"%s ́Ałɑ݂Ă܂B\n㏑Ă낵łH",cNewBuf);
		SendMessage(hwndParent,WM_IPSLIB_CONFIRM,(WPARAM)&blYesNo,(LPARAM)szMsg);
		if(!blYesNo){
			SendMessage(hwndParent,WM_IPSLIB_FINISH,FALSE,(LPARAM)NULL);
			return FALSE;
		}

		SetFileAttributes(cNewBuf,FILE_ATTRIBUTE_NORMAL);
	}
	
	if(!CopyFile(lpSrcPath,cNewBuf,FALSE)){
		wsprintf(szMsg,"̧ق߰ł܂B");
		SendMessage(hwndParent,WM_IPSLIB_FINISH,FALSE,(LPARAM)szMsg);
		return FALSE;
	}

	SetFileAttributes(cNewBuf,FILE_ATTRIBUTE_NORMAL);

	if(ips_Patch(cNewBuf,lpIPSPath,szLog,hwndParent,WM_IPSLIB_PROGRESS)){
		SendMessage(hwndParent,WM_IPSLIB_FINISH,TRUE,(LPARAM)szLog);
	}
	else{
		DeleteFile(cNewBuf);
		SendMessage(hwndParent,WM_IPSLIB_FINISH,FALSE,(LPARAM)szLog);
	}

	return TRUE;
}
