#define _WIN32_IE 0x0200
#include <windows.h>
#include <windowsx.h>
#include <tlhelp32.h>
#include <commctrl.h>
#include <stdio.h>
#include "winips.h"
#include "ipslib.h"
#include "ips.h"
#include "myfunc.h"
#include "resource.h"
#include "ini.h"

//
#define WM_IPSPATCH (WM_USER + 100) // lparam - text
//
#define MUTEXNAME "WINIPS_MUTEX"
#define CLASSNAME "WINIPS"
#define WNDTITLE  "WINIPS"

#define NUM_OPMODES 2
//0 - use, 1- create
//#define OPMODE_USE       0
//#define OPMODE_CREATE    1
//#define OPMODE_SFP       2
typedef enum {
	OPMODE_INVALID=-1,
	OPMODE_USE=0,
	OPMODE_CREATE=1
}WINIPS_OPMODE;

WINIPS_OPMODE giOpMode=OPMODE_USE;

TCHAR g_szBrowseInitPath1[NUM_OPMODES][MAX_PATH]={0};
TCHAR g_szBrowseInitPath2[NUM_OPMODES][MAX_PATH]={0};

BOOL g_fAlwaysOnTop=FALSE;

extern BOOL g_fUseAppDatDir;

static BOOL GetFileName(HWND hWnd,char *filefilter,char *fullpath,DWORD dwBufSize,LPSTR ptitle,LPTSTR szInitDir)
{
	OPENFILENAME fname;
    char filename[64]={0};
	char CurDir[MAX_PATH];

	GetCurrentDirectory(MAX_PATH,CurDir);

	memset(fullpath,0,dwBufSize);
    memset(&fname,0,sizeof(OPENFILENAME));

	fname.lStructSize=sizeof(fname);
	fname.lpstrInitialDir=szInitDir;
	fname.lpstrTitle=ptitle;
	fname.hwndOwner=hWnd;
	fname.lpstrFilter=filefilter;
	fname.nFilterIndex=0;
	fname.lpstrFile=fullpath;
	fname.nMaxFile=dwBufSize;
	fname.lpstrFileTitle=filename;
	fname.nMaxFileTitle=sizeof(filename);
	fname.Flags=OFN_HIDEREADONLY|OFN_FILEMUSTEXIST|OFN_NOCHANGEDIR;
			
	if (!GetOpenFileName(&fname))
		return FALSE;

	lstrcpyn(szInitDir,fullpath,fname.nFileOffset);

	return TRUE;
}

static void CenterDialogBox(HWND hDlg,HWND hWndOwner)
{
	RECT rcOwner,rcDlg;

	// Get parent window handle
	//hWndOwner=GetParent(hDlg);
	if(!hWndOwner) 
		hWndOwner=GetDesktopWindow();

	// 
	GetWindowRect(hWndOwner,&rcOwner);
	GetWindowRect(hDlg,&rcDlg);
	OffsetRect(&rcDlg,-rcDlg.left,-rcDlg.top);
	
	// 
	SetWindowPos(hDlg,
		         NULL,
				 rcOwner.left + (rcOwner.right-rcOwner.left)/2 - (rcDlg.right / 2),
				 rcOwner.top + (rcOwner.bottom-rcOwner.top)/2 - (rcDlg.bottom / 2),
				 0,0,
				 SWP_NOSIZE|SWP_NOZORDER); 
}

LRESULT CALLBACK VersionDlgProc(HWND hDlg,UINT message,WPARAM wParam,LPARAM lParam)
{
   switch (message)
   {
   case WM_INITDIALOG:
	   {
		   TCHAR szVersInfo[100];
		   HWND hWnd;
		   hWnd=(HWND)lParam;

		   CenterDialogBox(hDlg,hWnd);

		   wsprintf(szVersInfo,"WinIPS %d.%.2d",VERSION_MAJOR,VERSION_MINOR);
		   SetDlgItemText(hDlg,IDC_VERSION_WINIPS,szVersInfo);

		   return TRUE;
	   }
   case WM_COMMAND:
	   switch(LOWORD(wParam))
	   {
	   case IDOK:
		   {
			   EndDialog(hDlg, TRUE);
			   return TRUE;
		   }
	   }
   }
   return FALSE;
}

BOOL CheckCommandLine(LPSTR lpCmdLine,WINIPS_OPMODE *pOpmode,BOOL *pfUseAppDatDir,LPIPSLIBPARAMS lpILParams)
{
//	if(lpCmdLine[0]!='\0')
//	{
//		sscanf(lpCmdLine,"%s",lpILParams->szFilePath1);
//		if(!IsIPSFile(lpILParams->szFilePath1))
//			lpILParams->szFilePath1[0]='\0';
//		return FALSE;
//	}
//	else
//		return FALSE;
	LPSTR ps = lpCmdLine;
	LPTSTR pd;
	WINIPS_OPMODE opmode = OPMODE_INVALID;
	BOOL fuseappdatdir = FALSE, ferror = FALSE;
	DWORD dwpathindex = 0, len;

	while(*ps && !ferror) {
		switch(*ps)
		{
		case '/':
			ps++;
			switch(*ps)
			{
			case 'a':
				opmode = OPMODE_USE;
				break;
			case 'c':
				opmode = OPMODE_CREATE;
				break;
			case 'i':
				fuseappdatdir = TRUE;
				break;
//			default: // NULL\
//				ferror = TRUE;
			}
//			if (!ferror)
			if (*ps) // NULLłȂ
				ps++;
			break;
		case '"':
			if (dwpathindex == 0)
				pd = lpILParams->szFilePath1;
			else if (dwpathindex == 1)
				pd = lpILParams->szFilePath2;
			else {
				ferror = TRUE;
				break;
			}
			ps++;
			len = 0;
			while (*ps && *ps != '"' && len < MAX_PATH - 1) {
				*pd = *ps;
				ps++; pd++; len++;
			}
			if (*ps) ps++; // R}hC̃|C^I[łȂΎ
			*pd = 0; // Rs[̕NULLł߂
			dwpathindex++; // Ώۂ̃pXobt@XV
			break;
		case ' ':
			ps++; // 
			break;
		default:
			if (dwpathindex == 0) {
				len = strlen(ps);
				if (len < MAX_PATH - 1) {
					strcpy(lpILParams->szFilePath1, ps);
					ps += len; // R}hC̃|C^XV
					dwpathindex++; // Ώۂ̃pXobt@XV
					break;
				}
			}
			ferror = TRUE;
			break;
		}

	}

	// R}hCœKp[hw肳āAw肳ꂽt@CIPSt@C
	// łȂ΁ANA
//	if (opmode == OPMODE_USE
//		&& lstrlen(lpILParams->szFilePath1)
//		&& !IsIPSFile(lpILParams->szFilePath1))
//			lpILParams->szFilePath1[0]='\0';

	if (pOpmode)
		*pOpmode = opmode;
	if (pfUseAppDatDir)
		*pfUseAppDatDir = fuseappdatdir;

	return ferror;
}

static void EnableCommandControls(HWND hDlg,BOOL bEnable)
{
	EnableWindow(GetDlgItem(hDlg,IDC_OPERATION),bEnable);
	EnableWindow(GetDlgItem(hDlg,IDOK),bEnable);
	EnableWindow(GetDlgItem(hDlg,IDC_EDIT_FILE1),bEnable);
	EnableWindow(GetDlgItem(hDlg,IDC_EDIT_FILE2),bEnable);
	EnableWindow(GetDlgItem(hDlg,IDC_BUTTON_FILE1),bEnable);
	EnableWindow(GetDlgItem(hDlg,IDC_BUTTON_FILE2),bEnable);
	EnableWindow(GetDlgItem(hDlg,IDC_OPERATIONLABEL),bEnable);
	EnableWindow(GetDlgItem(hDlg,IDC_FILE1LABEL),bEnable);
	EnableWindow(GetDlgItem(hDlg,IDC_FILE2LABEL),bEnable);
	EnableWindow(GetDlgItem(hDlg,IDC_PARAMLABEL),bEnable);
}

void DisableControls(HWND hDlg)
{
	EnableCommandControls(hDlg,FALSE);
}

void ResetControls(HWND hDlg)
{
	TCHAR chNULL = '\0';
	EnableCommandControls(hDlg,TRUE);
	SendDlgItemMessage(hDlg,IDC_STATUSPROGRESS,PBM_SETPOS,0,0);
	SetDlgItemText(hDlg,IDC_STATUSTEXT,&chNULL);
}

void SetControlText(HWND hDlg,int iMode)
{
	struct{
		LPTSTR lpFile1;
		LPTSTR lpFile2;
		LPTSTR lpExeButton;
	}sLabelName[NUM_OPMODES]
		={
			{"IPŞ","̧߯","Kp(&P)"},
			{"ύXO̧","ύX̧","쐬(&C)"}};

	SendDlgItemMessage(hDlg,IDC_OPERATION,CB_SETCURSEL,iMode,0);
	SetDlgItemText(hDlg,IDC_FILE1LABEL,sLabelName[iMode].lpFile1);
	SetDlgItemText(hDlg,IDC_FILE2LABEL,sLabelName[iMode].lpFile2);
	SetDlgItemText(hDlg,IDOK,sLabelName[iMode].lpExeButton);
	SetDlgItemText(hDlg,IDC_EDIT_FILE1,"");
	SetDlgItemText(hDlg,IDC_EDIT_FILE2,"");

	SendDlgItemMessage(hDlg,IDC_EDIT_FILE1,EM_SETLIMITTEXT,MAX_PATH,0);
	SendDlgItemMessage(hDlg,IDC_EDIT_FILE2,EM_SETLIMITTEXT,MAX_PATH,0);
}

#define SET_TOP(h) SetWindowPos((h),HWND_TOPMOST,0,0,0,0,SWP_NOMOVE|SWP_NOSIZE)

#define SET_NOTOP(h) SetWindowPos((h),HWND_NOTOPMOST,0,0,0,0,SWP_NOMOVE|SWP_NOSIZE)

void _CheckMenuItem(HWND hWnd,UINT uItemID,BOOL blCheck)
{
	MENUITEMINFO mii;

	memset(&mii,0,sizeof(MENUITEMINFO));
	mii.cbSize=sizeof(MENUITEMINFO);
	mii.fMask=MIIM_STATE;
	if(blCheck)
		mii.fState|=MFS_CHECKED;
	else
		mii.fState&=~MFS_CHECKED;
	SetMenuItemInfo(GetMenu(hWnd),uItemID,FALSE,&mii);
}

static BOOL IsEditboxEmpty(HWND hDlg,int nIDDlgItem)
{
	return (!GetWindowTextLength(GetDlgItem(hDlg,nIDDlgItem)))?TRUE:FALSE;
}

static BOOL Exit(HWND hDlg,int nResult,HANDLE hThread)
{
	if(!hThread){
		PostQuitMessage(0);
		EndDialog(hDlg,nResult);
		return TRUE;
	}
	return FALSE;
}

LRESULT CALLBACK MainDlgProc( HWND hDlg,UINT message,WPARAM wParam,LPARAM lParam)
{
   static LPIPSLIBPARAMS lpILParams;
   static HANDLE hThread = NULL;
   switch (message)
   {
   case WM_INITDIALOG:
	   {
		   int n;
		   HICON hAppIcon,hOpenIcon;
		   LPTSTR lpOperation[NUM_OPMODES]={"IPS߯", "IPŞٍ쐬"};

		   //
		   lpILParams = (LPIPSLIBPARAMS)lParam;

		   hAppIcon=LoadIcon(GetModuleHandle(NULL), "APPICON");
		   SendMessage(hDlg, WM_SETICON, (WPARAM)ICON_BIG, (LPARAM)hAppIcon);
		   SendMessage(hDlg, WM_SETICON, (WPARAM)ICON_SMALL, (LPARAM)hAppIcon);
		   
		   hOpenIcon=LoadIcon(GetModuleHandle(NULL), "BROWSEICON");
		   SendDlgItemMessage(hDlg, IDC_BUTTON_FILE1, BM_SETIMAGE, (WPARAM)IMAGE_ICON, (LPARAM)hOpenIcon);
		   SendDlgItemMessage(hDlg, IDC_BUTTON_FILE2, BM_SETIMAGE, (WPARAM)IMAGE_ICON, (LPARAM)hOpenIcon);

		   for(n = 0; n < NUM_OPMODES; n++)
			   SendDlgItemMessage(hDlg, IDC_OPERATION, CB_ADDSTRING, (WPARAM)0, (LPARAM)lpOperation[n]);

		   SendDlgItemMessage(hDlg, IDC_STATUSPROGRESS, PBM_SETRANGE, 0, MAKELPARAM(0, 100));

		   SetControlText(hDlg, giOpMode);

		   if(g_fAlwaysOnTop) SET_TOP(hDlg);

		   // APPLICATION_NAME^CgɂȂĂ邱Ƃۏ
		   SetWindowText(hDlg, APPLICATION_NAME);

		   //
		   SetDlgItemText(hDlg, IDC_EDIT_FILE1, lpILParams->szFilePath1);


		   return TRUE;
	   }
   case WM_SYSCOMMAND:
	   {
		   DWORD uCmdType = wParam;        // type of system command requested 
		   WORD xPos = LOWORD(lParam);    // horizontal position, in screen coordinates 
		   WORD yPos = HIWORD(lParam);    // vertical position, in screen coordinates 
		   
		   switch(uCmdType)
		   {
		   case SC_CLOSE:
			   Exit(hDlg,TRUE,hThread);
			   break;
		   case SC_MAXIMIZE:
		   case SC_SIZE:
			   return TRUE;
		   }
	   }
	   break;
   case WM_INITMENU:
	   {
		   if(g_fAlwaysOnTop)
			   _CheckMenuItem(hDlg,IDM_OPTION_ALWAYSONTOP,TRUE);
		   else
			   _CheckMenuItem(hDlg,IDM_OPTION_ALWAYSONTOP,FALSE);
		   
		   return TRUE;
	   }
   case WM_DROPFILES:
	   {
		   POINT pt;
		   HDROP hDrop=(HDROP)wParam;
		   TCHAR szFileName[MAX_PATH];
		   HWND hChildWnd;
		   UINT n,nFiles;
		   if(DragQueryPoint(hDrop,&pt)){
			   nFiles=DragQueryFile(hDrop,0xFFFFFFFF,NULL,0);
			   for(n=0;n<nFiles;n++){
				   DragQueryFile(hDrop,n,szFileName,MAX_PATH*sizeof(TCHAR));
				   hChildWnd=ChildWindowFromPoint(hDlg,pt);
				   if(hChildWnd==GetDlgItem(hDlg,IDC_EDIT_FILE1)
					   || hChildWnd==GetDlgItem(hDlg,IDC_EDIT_FILE2))
					   SetWindowText(hChildWnd,szFileName);
				   else if(giOpMode==OPMODE_USE){
					   TCHAR szFileExt[MAX_PATH]={0};
					   GetFileExtention(szFileName,szFileExt,MAX_PATH*sizeof(TCHAR));
					   CharLower(szFileExt);
					   if(!memcmp("ips",szFileExt,3*sizeof(TCHAR))){
						   hChildWnd=GetDlgItem(hDlg,IDC_EDIT_FILE1);
						   SetWindowText(hChildWnd,szFileName);
					   }
					   else if(giOpMode==OPMODE_USE){
						   hChildWnd=GetDlgItem(hDlg,IDC_EDIT_FILE2);
						   SetWindowText(hChildWnd,szFileName);
					   }
				   }
				   SetFocus(hChildWnd);
			   }// for
			   SetForegroundWindow(hDlg);
		   }
		   DragFinish(hDrop);
		   return TRUE;
	   }
   case WM_IPSPATCH:
	   {
		   LPTSTR lpText = (LPTSTR)lParam;
		   if(lpText){
			   SendMessage(hDlg,WM_COMMAND,(WPARAM)MAKEWPARAM(IDM_FILE_IPSUSE,0),(LPARAM)NULL);
			   SetDlgItemText(hDlg,IDC_EDIT_FILE1,lpText);
		   }
		   return TRUE;
	   }
   case WM_IPSLIB_BEGIN:
	   {
		   DisableControls(hDlg);
		   return TRUE;
	   }
   case WM_IPSLIB_FINISH:
	   {
		   LPTSTR lpMsg = (LPTSTR)lParam;
		   BOOL   blSuccess = (BOOL)wParam;
		   if(blSuccess){
			   if(lpMsg)
				   MessageBox(hDlg,lpMsg,APPLICATION_NAME,MB_OK|MB_ICONINFORMATION);
		   }
		   else{
			   if(lpMsg)
				   MessageBox(hDlg,lpMsg,APPLICATION_NAME,MB_OK|MB_ICONEXCLAMATION);
		   }

		   hThread = NULL;
		   ResetControls(hDlg);
		   
		   return TRUE;
	   }
	   /*
   case WM_IPSLIB_ERROR:
	   {
		   if(lParam)
			   MessageBox(hDlg,(LPTSTR)lParam,APPLICATION_NAME,MB_OK|MB_ICONINFORMATION);
		   
		   hThread = NULL;

		   ResetControls(hDlg);
		   
		   return TRUE;
	   }
	   */
   case WM_IPSLIB_CONFIRM:
	   {
		   LPBOOL lpYesNO = (LPBOOL)wParam;
		   *lpYesNO = TRUE;
		   if(IDNO==MessageBox(hDlg,(LPTSTR)lParam,APPLICATION_NAME,MB_YESNO|MB_ICONQUESTION))
			   *lpYesNO = FALSE;
		   return TRUE;
	   }
   case WM_IPSLIB_PROGRESS:
	   {
		   SendDlgItemMessage(hDlg,IDC_STATUSPROGRESS,PBM_SETPOS,wParam,0);
		   if(lParam)
			   SetDlgItemText(hDlg,IDC_STATUSTEXT,(LPTSTR)lParam);
		   return TRUE;
	   }
   case WM_COMMAND:
		   {
			   WORD wNotifyCode = HIWORD(wParam); // notification code 
			   WORD wID = LOWORD(wParam);         // item, control, or accelerator identifier 
			   HWND hWndCtl = (HWND) lParam;      // handle of control 
            switch(wID)
			{
			case IDM_FILE_EXIT:
				Exit(hDlg,TRUE,hThread);
				return TRUE;
			case IDM_FILE_IPSUSE:
				giOpMode=OPMODE_USE;
				goto MENU_OP;
			case IDM_FILE_IPSCREATE:
				giOpMode=OPMODE_CREATE;
				//goto MENU_OP;
MENU_OP:
				SetControlText(hDlg,giOpMode);
				return TRUE;
			case IDM_FILE_BROWSE1:
				{
					char filefilterALL[]= {'A','l','l','(','*','.','*',')','\0','*','.','*','\0','\0','\0'};
					char filefilterIPS[]= {'I','P','S','(','*','.','i','p','s',')','\0','*','.','i','p','s','\0','\0','\0'};
					BOOL blRet=FALSE;
					TCHAR cBuf[MAX_PATH];

					switch(giOpMode)
					{
					case OPMODE_USE:
						blRet=GetFileName(hDlg,filefilterIPS,cBuf,MAX_PATH,NULL,g_szBrowseInitPath1[OPMODE_USE]);
						break;
					case OPMODE_CREATE:
						blRet=GetFileName(hDlg,filefilterALL,cBuf,MAX_PATH,NULL,g_szBrowseInitPath1[OPMODE_CREATE]);
						break;
					}
					if(blRet){
						SetDlgItemText(hDlg,IDC_EDIT_FILE1,cBuf);
					}
					return TRUE;
				}
			case IDM_FILE_BROWSE2:
				{
					char filefilterALL[]= {'A','l','l','(','*','.','*',')','\0','*','.','*','\0','\0','\0'};
					TCHAR cBuf[MAX_PATH];

					if(GetFileName(hDlg,filefilterALL,cBuf,MAX_PATH,NULL,g_szBrowseInitPath2[giOpMode])){
						SetDlgItemText(hDlg,IDC_EDIT_FILE2,cBuf);
					}
					return TRUE;
				}
			case IDM_OPTION_ALWAYSONTOP:
				g_fAlwaysOnTop=(g_fAlwaysOnTop)?FALSE:TRUE;
				if(g_fAlwaysOnTop)
					SET_TOP(hDlg);
				else
					SET_NOTOP(hDlg);
				return TRUE;
			case IDM_HELP_VERSION:
				DialogBoxParam(GetModuleHandle(NULL),"VERSIONDLG",hDlg,VersionDlgProc,(LPARAM)hDlg);
				return TRUE;
			case IDC_BUTTON_FILE1:
				{
					if(wNotifyCode==BN_CLICKED)
						SendMessage(hDlg,WM_COMMAND,MAKEWPARAM(IDM_FILE_BROWSE1,0),lParam);
					return TRUE;
				}
			case IDC_BUTTON_FILE2:
				{
					if(wNotifyCode==BN_CLICKED)
						SendMessage(hDlg,WM_COMMAND,MAKEWPARAM(IDM_FILE_BROWSE2,0),lParam);
					return TRUE;
				}
			case IDC_EDIT_FILE1:
				{
					if(wNotifyCode==EN_UPDATE || wNotifyCode==WM_SETTEXT){
						HWND hExeBtn;
						BOOL fExeBtnEnabled,fExeBtnState;
						hExeBtn=GetDlgItem(hDlg,IDOK);
						fExeBtnEnabled=
							(IsEditboxEmpty(hDlg,IDC_EDIT_FILE1)
							|| IsEditboxEmpty(hDlg,IDC_EDIT_FILE2) ) ? FALSE : TRUE;
						fExeBtnState=IsWindowEnabled(hExeBtn);
						if(fExeBtnEnabled!=fExeBtnState)
							EnableWindow(hExeBtn,fExeBtnEnabled);
					}
					return TRUE;
				}
			case IDC_EDIT_FILE2:
				{
					if(wNotifyCode==EN_UPDATE || wNotifyCode==WM_SETTEXT){
						HWND hExeBtn;
						BOOL fExeBtnEnabled,fExeBtnState;
						hExeBtn=GetDlgItem(hDlg,IDOK);
						fExeBtnEnabled=
							(IsEditboxEmpty(hDlg,IDC_EDIT_FILE1)
							|| IsEditboxEmpty(hDlg,IDC_EDIT_FILE2) ) ? FALSE : TRUE;
						fExeBtnState=IsWindowEnabled(hExeBtn);
						if(fExeBtnEnabled!=fExeBtnState)
							EnableWindow(hExeBtn,fExeBtnEnabled);
					}
					return TRUE;
				}
			case IDOK:
				{
					DWORD dwThreadID;
					if(!hThread){
						GetDlgItemText(hDlg,IDC_EDIT_FILE1,lpILParams->szFilePath1,MAX_PATH);
						GetDlgItemText(hDlg,IDC_EDIT_FILE2,lpILParams->szFilePath2,MAX_PATH);
					
						lpILParams->hWnd = hDlg;

						if(!strlen(lpILParams->szFilePath1)
							|| !strlen(lpILParams->szFilePath2)) return TRUE;
					
						switch(giOpMode){
						case OPMODE_USE:
							hThread = CreateThread(NULL,0,(LPTHREAD_START_ROUTINE)IPSPatch,lpILParams,0,&dwThreadID);
							break;
						case OPMODE_CREATE:
							hThread = CreateThread(NULL,0,(LPTHREAD_START_ROUTINE)CreateIPSFile,lpILParams,0,&dwThreadID);
							break;
						}
					}
					return TRUE;
				}
				break;
			case IDC_OPERATION:
				{
				   switch(HIWORD(wParam))
				   {
				   case CBN_SELCHANGE:
					   {
						   int iSel;
						   iSel=SendDlgItemMessage(hDlg,IDC_OPERATION,CB_GETCURSEL,0,0);
						   if(iSel!=CB_ERR){
							   giOpMode=iSel;
							   SetControlText(hDlg,giOpMode);
						   }
					   }
					   break;
				   }
				}
				break;
			}
			}// WM_COMMAND
   }
   return FALSE;
}

static HWND ActivateWinIPS()
{
	HWND hWnd;
	hWnd = FindWindow("#32770",APPLICATION_NAME);
	SetForegroundWindow(hWnd);
	return hWnd;
}


#define INI_APPNAME_OPTION      "OPTION"
#define INI_KEYNAME_ALWAYSONTOP "ALWAYSONTOP"
#define INI_APPNAME_INITDIR     "INITDIR"
#define INI_KEYNAME_INITDIR     "P%dM%d"
//#define INI_APPNAME_SETTING     "SETTING"
//#define INI_KEYNAME_OPMODE      "OPMODE"

static void LoadGlobalValue()
{
	int n;
	TCHAR szKeyName[5];

	for(n=0;n<NUM_OPMODES;n++){
		wsprintf(szKeyName,INI_KEYNAME_INITDIR,1,n);
		GetStringFromINI(INI_APPNAME_INITDIR,szKeyName,"\x00",g_szBrowseInitPath1[n],MAX_PATH);
		wsprintf(szKeyName,INI_KEYNAME_INITDIR,2,n);
		GetStringFromINI(INI_APPNAME_INITDIR,szKeyName,"\x00",g_szBrowseInitPath2[n],MAX_PATH);
	}
	
	g_fAlwaysOnTop=GetIntegerFromINI(INI_APPNAME_OPTION,INI_KEYNAME_ALWAYSONTOP,0);
}

static void SaveGlobalValue()
{
	int n;
	TCHAR szKeyName[5];

	for(n=0;n<NUM_OPMODES;n++){
		wsprintf(szKeyName,INI_KEYNAME_INITDIR,1,n);
		WriteStringToINI(INI_APPNAME_INITDIR,szKeyName,g_szBrowseInitPath1[n]);
		wsprintf(szKeyName,INI_KEYNAME_INITDIR,2,n);
		WriteStringToINI(INI_APPNAME_INITDIR,szKeyName,g_szBrowseInitPath2[n]);
	}

	WriteIntegerToINI(INI_APPNAME_OPTION,INI_KEYNAME_ALWAYSONTOP,g_fAlwaysOnTop);
}


int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow)
{
	IPSLIBPARAMS ilParams;
	HANDLE hMutex;

	ilParams.szFilePath1[0] = '\0';
	ilParams.szFilePath2[0] = '\0';
	ilParams.hWnd = NULL;

	if(!CheckCommandLine(lpCmdLine,&giOpMode,&g_fUseAppDatDir,&ilParams)){

		if (giOpMode == OPMODE_INVALID) { // GUI[hŋN
			// GUI̐ݒǂݍށBini.cŎgpg_fUseAppDatDir\ߏĂȂĂ͂ȂȂB
			LoadGlobalValue();
			//
			giOpMode = OPMODE_USE;
			//
			InitCommonControls();
			// dNo
			hMutex=CreateMutex(NULL,TRUE,MUTEXNAME);
			if(GetLastError()==ERROR_ALREADY_EXISTS){
				HWND hWnd;
				hWnd=ActivateWinIPS();
				if(lpCmdLine[0]!='\0'){
					// TODO : ́AقȂvZX֎vZX̃AhXԂ̃|C^
					// nĂ邱ƂɂȂ̂ŁA낵ȂA삷B
					SendMessage(hWnd,WM_IPSPATCH,0,(LPARAM)lpCmdLine);
				}
				goto EXIT_PROGRAM;
			}

			// 
			DialogBoxParam(hInstance,"MAINWNDDLG",NULL,(DLGPROC)MainDlgProc,(LPARAM)&ilParams);

			if(hMutex) CloseHandle(hMutex);

			SaveGlobalValue();

		}
		else { // GUIŋN
			BOOL fresult;
			// NOTE : Rs[A㏑Ȃǂ̊mF
			// Ɩ߂l0ŁAsƖ߂l1ɂȂ
			switch(giOpMode)
			{
			case OPMODE_USE:
				fresult = IPSPatch(&ilParams);
				return fresult ? 0 : 1;
			case OPMODE_CREATE:
				fresult = CreateIPSFile(&ilParams);
				return fresult ? 0 : 1;
			}
		}
	}

EXIT_PROGRAM:

	return 0;

}
